#ifndef GC_THREADINGSPACE_HH_
#define GC_THREADINGSPACE_HH_

#include <gecode/kernel.hh>
#include <gecode/int.hh>
#include <gecode/search.hh>
#include <gecode/minimodel.hh>

#include <string>

#include "cpsp/HCore.hh"
#include "cpsp/HPThreadingOptions.hh"

namespace cpsp
{
  namespace gecode
  {
  	
	class GC_ThreadingSpace : public Gecode::Space
	{
	private:
			
			//! the position domains for the sequence elements
		Gecode::IntVarArray domains;
		
	public:
		GC_ThreadingSpace(HPThreadingOptions& opts, HCore& hCore);
		GC_ThreadingSpace(bool share, GC_ThreadingSpace& toCopy);
		virtual ~GC_ThreadingSpace();
		
		virtual Gecode::Space* copy(bool share);

			//! Returns a vector of indexed points thats a structure for
			//! the current CPSP.		
		ell::IndexVec getSolution() const;
	};

  } // namespace gecode	
} // namespace cpsp

#endif /*GC_THREADINGSPACE_HH_*/
